package com.fs.his.service;

import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.fs.common.core.domain.R;
import com.fs.company.param.FsStoreStatisticsParam;
import com.fs.company.vo.FsStoreOrderStatisticsVO;
import com.fs.his.domain.FsStoreAfterSales;
import com.fs.his.domain.FsStoreAfterSalesItem;
import com.fs.his.domain.FsStoreAfterSalesLogs;
import com.fs.his.param.*;
import com.fs.his.vo.*;

/**
 * 售后记录Service接口
 *
 * @author fs
 * @date 2023-06-13
 */
public interface IFsStoreAfterSalesService
{
    /**
     * 查询售后记录
     *
     * @param id 售后记录主键
     * @return 售后记录
     */
    public FsStoreAfterSales selectFsStoreAfterSalesById(Long id);

    /**
     * 查询售后记录列表
     *
     * @param fsStoreAfterSales 售后记录
     * @return 售后记录集合
     */
    public List<FsStoreAfterSales> selectFsStoreAfterSalesList(FsStoreAfterSales fsStoreAfterSales);

    /**
     * 新增售后记录
     *
     * @param fsStoreAfterSales 售后记录
     * @return 结果
     */
    public int insertFsStoreAfterSales(FsStoreAfterSales fsStoreAfterSales);

    /**
     * 修改售后记录
     *
     * @param fsStoreAfterSales 售后记录
     * @return 结果
     */
    public int updateFsStoreAfterSales(FsStoreAfterSales fsStoreAfterSales);

    /**
     * 批量删除售后记录
     *
     * @param ids 需要删除的售后记录主键集合
     * @return 结果
     */
    public int deleteFsStoreAfterSalesByIds(Long[] ids);

    /**
     * 删除售后记录信息
     *
     * @param id 售后记录主键
     * @return 结果
     */
    public int deleteFsStoreAfterSalesById(Long id);

    List<FsStoreAfterSalesListVO> selectFsStoreAfterSalesListVO(FsStoreAfterSalesParam fsStoreAfterSales);

    List<FsStoreAfterSalesItem> selectFsStoreAfterSalesItemById(Long id);

    List<FsStoreAfterSalesLogsVO> selectFsStoreAfterSalesLogById(Long id);

    Long selectFsOrderIdByCode(Long id);

    int auditing(FsStoreAfterSales fsStoreAfterSales);

    int noAuditing(FsStoreAfterSales fsStoreAfterSales);

    int refundMoney(FsStoreAfterSales fsStoreAfterSales);

    List<FsStoreAfterSalesExcelVO> selectFsStoreAfterSalesExcelListVO(FsStoreAfterSalesParam fsStoreAfterSales);

    FsStoreAfterSalesVO selectFsStoreAfterSalesVOById(Long id);

    R applyAfterSales(long uesrId, FsStoreAfterSalesApplyParam param);

    R revoke(long userId, FsStoreAfterSalesRevokeParam param);

    R addDelivery(FsStoreAfterSalesDeliveryParam param);

    int depotAuditing(FsStoreAfterSales fsStoreAfterSales);

    List<FsStoreAfterSalesListUVO> selectFsStoreAfterSalesListUVO(FsStoreAfterSalesListUParam param);

    List<FsStoreAfterSales> selectFsStoreAfterSalesByDoAudit();

    Boolean isEntityNull(FsStoreAfterSalesParam fsStoreAfterSales);

    Long selectFsStoreAfterSalesExcelListVOCount(FsStoreAfterSalesParam fsStoreAfterSales);

    void exportData(FsStoreAfterSalesParam fsStoreAfterSales);

    List<FsStoreOrderStatisticsVO> selectFsStoreAfterSalesServiceStatisticsList(FsStoreStatisticsParam param);

    List<JSONObject> selectFsStoreAfterSales(Map<String, Object> map);
}
